from pylab import *
from scipy.optimize import leastsq

def tr_FP(opd,p):
    return p[0]*(1.)/(1+p[1]**2*sin(pi/0.6328*p[4]*opd+p[2])**2) +p[3]


monte=loadtxt("scan_francesco.dat")
#descente=load("scan_pression_descente.dat")


opdm=monte[:,0]*14.606*0.000293
#opdd=descente[:,0]*14.606*0.000293
clf()

opd=linspace(0,1.4,1000)

err = lambda p,x,y : y-tr_FP(x,p)

p0=array([160,10,0,0.5,1])
p,err = leastsq(err,p0,args=(r_[opdm],r_[monte[:,1]]))



plot(opdm*p[4],monte[:,1],".")
#plot(opdd*p[4],descente[:,1],".")
nair=p[4]*2.93e-4
p[4]=1
plot(opd,tr_FP(opd,p))
da=tr_FP(opd,p)
c=max(da)/min(r_[monte[:,1]])
text(0.72,8," Finesse = %0.1f\n\n $\mathsf{(n_{air} - 1)}=$ %0.2e . P\n\nContrast : $\mathsf{I_{min}/I_{max}=}$%d"%(abs(p[1])/2*pi,nair,ceil(c)))

xlabel("OPD in $\mu m$")
ylabel("Flux in ADU")
ylim(0,200)
legend(("Pressure Increasing","Model"),"upper center")
savefig("FP_pressure_linescan3.png")
savefig("FP_pressure_linescan.eps")
